Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
FSDK.AssociatedFiles Class Reference

## Public Member Functions
| AssociateFile (annot, file_spec)
| Associate a file (represented by FSDK.FileSpec) with a PDF annotation. More...
| AssociateFile (form_xobject, file_spec)
| Associate a file (represented by FSDK.FileSpec) with a form XObject graphics object. More...
| AssociateFile (graphics_object, mark_content_item_index, current_resource, property_name, file_spec)
| Associate a file (represented by FSDK.FileSpec) with a marked content item of a specified graphics object. More...
| AssociateFile (image, file_spec)
| Associate a file (represented by FSDK.FileSpec) with an image graphics object. More...
| AssociateFile (page, file_spec)
| Associate a file (represented by FSDK.FileSpec) with a PDF page. More...
| AssociateFile (pdf_object, file_spec)
| Associate a file (represented by FSDK.FileSpec) with a PDF dictionary object which represents the dictionary of an annotation, a PDF page, or other object in PDF document. More...
| constructor (pdf_doc)
| Constructor, with a PDF document. More...
| GetAssociatedFile (graphics_object, index)
| Get an associated file a graphics object, by index. More...
| GetAssociatedFile (pdf_object, index)
| Get an associated file (represented by FSDK.FileSpec) in a specified PDF dictionary object, by index. More...
| GetAssociatedFilesCount (graphics_object)
| Get the count of associated files in a graphics object. More...
| GetAssociatedFilesCount (pdf_object)
| Get the count of associated files in a PDF dictionary object which represents the dictionary of an annotation, a PDF page, or other object in PDF document. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| RemoveAssociatedFile (graphics_object, index)
| Remove an associated file a graphics object, by index. More...
| RemoveAssociatedFile (pdf_object, index)
| Remove an associated file (represented by FSDK.FileSpec) in a specified PDF dictionary object, by index. More...

## Static Public Attributes
static | e_RelationshipAlternative
| The relationship is "Alternative" which means the file specification is an alternative representation of content, for example audio.
static | e_RelationshipData
| The relationship is "Data" which means the file specification represents information used to derive a visual presentation - such as for a table or a graph.
static | e_RelationshipEncryptedPayload
| The relationship is "Encrypted payload" which means the file specification is an encrypted payload document that should be displayed to the user if the PDF processor has the cryptographic filter needed to decrypt the document.
static | e_RelationshipFormData
| The relationship is "Form data" which means the file specification is the data associated with the "AcroForm" dictionary in the PDF file.
static | e_RelationshipSchema
| The relationship is "Schema" which means the file specification is a schema definition for the associated object.
static | e_RelationshipSource
| The relationship is "Source" which means the file specification is the original source material for the associated content.
static | e_RelationshipSupplement
| The relationship is "Supplement" which means the file specification represents a supplemental representation of the original source or data that may be more easily consumable.
static | e_RelationshipUnspecified
| Enumeration for the relationship between PDF document and the associated file. More...

## Detailed Description

In PDF 2.0, a new concept named "Associated files" is defined. Associated files provide a means to associate content in other formats with objects of a PDF file and identify the relationship between the content and the objects. Such associated files are designated using file specification dictionaries (known as file specification). Associated files could be linked to the PDF document's catalog, a page dictionary, graphics objects, structure elements, XObject, DParts, an annotation dictionary and so on. Specially, associated files with graphics objects means to be associated with the marked content item.
Class FSDK.AssociatedFiles is the class for managing associate files. It offers the functions to count/get associate files in PDF dictionary or graphics object, to associate files (represented by FSDK.FileSpec) with catalog, PDF pages, graphics objects, form XObject objects, annotation objects and so on.
Specially, when construct an associated files object with a PDF document, the file version of the related PDF document will be set to 2.0.

## Member Function Documentation

## ◆ AssociateFile() [1/6]

FSDK.AssociatedFiles.AssociateFile | ( | annot | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with a PDF annotation.

In fact, this function is equals to associate a file with a PDF dictionary of a PDF annotation.

Parameters

  [in] | annot | A valid PDF annotation.
  [in] | file_spec | A file specification object to be associated with specified PDF annotation object. It should not be an empty string.

Returns
  None.

## ◆ AssociateFile() [2/6]

FSDK.AssociatedFiles.AssociateFile | ( | form_xobject | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with a form XObject graphics object.

In fact, this function is equals to associate a file with a PDF dictionary of a form XObject graphics object.

Parameters

  [in] | form_xobject | A form XObject graphics object. It should not be null.
  [in] | file_spec | A file specification object to be associated with specified form XObject graphics object. It should not be an empty string.

Returns
  None.

## ◆ AssociateFile() [3/6]

FSDK.AssociatedFiles.AssociateFile | ( | graphics_object | ,
|  | mark_content_item_index | ,
|  | current_resource | ,
|  | property_name | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with a marked content item of a specified graphics object.

Parameters

  [in] | graphics_object | A valid graphics object.
  [in] | mark_content_item_index | The index of marked content item in input graphic object to which the specified file specification object is to associated with. Valid range: from 0 to (count-1). count is returned by function FSDK.MarkedContent.GetItemCount of the marked content related to input graphics object.
  [in] | current_resource | A resource dictionary of a PDF page to which input graphics object is related. This can also be a PDF reference object that refers to such a PDF dictionary.
  [in] | property_name | A property name used in "Properties" dictionary of input resource dictionary. It should not be an empty string.
  [in] | file_spec | A file specification object to be associated with specified marked content item of a specified graphics object. It should not be an empty string.

Returns
  None.

Note
  When this function succeeds, function FSDK.GraphicsObjects.GenerateContent should be called. Please refer to function FSDK.GraphicsObjects.GenerateContent for more details.

## ◆ AssociateFile() [4/6]

FSDK.AssociatedFiles.AssociateFile | ( | image | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with an image graphics object.

In fact, this function is equals to associate a file with a PDF dictionary of an image graphics object.

Parameters

  [in] | image | An image graphics object. It should not be null.
  [in] | file_spec | A file specification object to be associated with specified image graphics object. It should not be an empty string.

Returns
  None.

## ◆ AssociateFile() [5/6]

FSDK.AssociatedFiles.AssociateFile | ( | page | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with a PDF page.

In fact, this function is equals to associate a file with a PDF page dictionary.

Parameters

  [in] | page | A valid PDF page.
  [in] | file_spec | A file specification object to be associated with specified PDF page. It should not be an empty string.

Returns
  None.

## ◆ AssociateFile() [6/6]

FSDK.AssociatedFiles.AssociateFile | ( | pdf_object | ,
|  | file_spec |
| ) |  |

Associate a file (represented by FSDK.FileSpec) with a PDF dictionary object which represents the dictionary of an annotation, a PDF page, or other object in PDF document.

Parameters

  [in] | pdf_object | A valid PDF object. It should be either a PDF dictionary object or a PDF reference object that refers to a PDF dictionary object.
  [in] | file_spec | A file specification object to be associated with specified PDF dictionary. It should not be an empty string.

Returns
  None.

## ◆ constructor()

FSDK.AssociatedFiles.constructor | ( | pdf_doc |  | ) |

Constructor, with a PDF document.

When an associated files object is constructed by this constructor, the file version of input PDF document will be set to 2.0.

Parameters

  [in] | pdf_doc | A valid PDF document object.

## ◆ GetAssociatedFile() [1/2]

FSDK.AssociatedFiles.GetAssociatedFile | ( | graphics_object | ,
|  | index |
| ) |  |

Get an associated file a graphics object, by index.

One or more files may be associated with sections of content in a content stream by enclosing those sections between the marked content. So, in fact, this function is to get an associated files (specified by index) in the marked content related to the graphics object.

Parameters

  [in] | graphics_object | A valid PDF graphics object.
  [in] | index | The index of an associated file in the specified PDF graphics object. Valid range: from 0 to (count-1). count is returned by function FSDK.AssociatedFiles.GetAssociatedFilesCount with same parameter graphics_object.

Returns
  A file specification object that represents the expected associated file.

## ◆ GetAssociatedFile() [2/2]

FSDK.AssociatedFiles.GetAssociatedFile | ( | pdf_object | ,
|  | index |
| ) |  |

Get an associated file (represented by FSDK.FileSpec) in a specified PDF dictionary object, by index.

Parameters

  [in] | pdf_object | A valid PDF object. It should be either a PDF dictionary object or a PDF reference object that refers to a PDF dictionary object.
  [in] | index | The index of an associated file in the specified PDF dictionary object. Valid range: from 0 to (count-1). count is returned by function FSDK.AssociatedFiles.GetAssociatedFilesCount with same parameter object.

Returns
  A file specification object that represents the expected associated file.

## ◆ GetAssociatedFilesCount() [1/2]

FSDK.AssociatedFiles.GetAssociatedFilesCount | ( | graphics_object |  | ) |

Get the count of associated files in a graphics object.

One or more files may be associated with sections of content in a content stream by enclosing those sections between the marked content. So, in fact, this function is to count associated files in the marked content related to the graphics object.

Parameters

  [in] | graphics_object | A valid PDF graphics object.

Returns
  The count of associated files.

## ◆ GetAssociatedFilesCount() [2/2]

FSDK.AssociatedFiles.GetAssociatedFilesCount | ( | pdf_object |  | ) |

Get the count of associated files in a PDF dictionary object which represents the dictionary of an annotation, a PDF page, or other object in PDF document.

Parameters

  [in] | pdf_object | A valid PDF object. It should be either a PDF dictionary object or a PDF reference object that refers to a PDF dictionary object.

Returns
  The count of associated files.

## ◆ IsEmpty()

FSDK.AssociatedFiles.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ RemoveAssociatedFile() [1/2]

FSDK.AssociatedFiles.RemoveAssociatedFile | ( | graphics_object | ,
|  | index |
| ) |  |

Remove an associated file a graphics object, by index.

One or more files may be associated with sections of content in a content stream by enclosing those sections between the marked content. So, in fact, this function is to count associated files in the marked content related to the graphics object.

Parameters

  [in] | graphics_object | A valid PDF graphics object.
  [in] | index | The index of an associated file in the specified PDF graphics object. Valid range: from 0 to (count-1). count is returned by function FSDK.AssociatedFiles.GetAssociatedFilesCount with same parameter graphics_object.

Returns
  A file specification object that represents the expected associated file.

## ◆ RemoveAssociatedFile() [2/2]

FSDK.AssociatedFiles.RemoveAssociatedFile | ( | pdf_object | ,
|  | index |
| ) |  |

Remove an associated file (represented by FSDK.FileSpec) in a specified PDF dictionary object, by index.

Parameters

  [in] | pdf_object | A valid PDF object. It should be either a PDF dictionary object or a PDF reference object that refers to a PDF dictionary object.
  [in] | index | The index of an associated file in the specified PDF dictionary object. Valid range: from 0 to (count-1). count is returned by function FSDK.AssociatedFiles.GetAssociatedFilesCount with same parameter object.

Returns
  None.

## Member Data Documentation

## ◆ e_RelationshipUnspecified

FSDK.AssociatedFiles.e_RelationshipUnspecified
| static

Enumeration for the relationship between PDF document and the associated file.

Values of this enumeration should be used alone.

The relationship is not known or cannot be described by other values.